
/*

La biblothque est trs rcente, il y a donc peu d'aide  son propos.
Les quelques fonctions qu'elle exporte sont dcrite ci-aprs.

Sous devC++ vous devrez linker votre programme  toute les lib ncessaire,
c'est  dire opengl, glu, adviogl, advio2 et mklib
Sous Visual C++, vous devez tlcharger et installer la lib advio2 (c'est  dire
copier les fichier dans les bon rpertoire (tout comme pour cette lib)) puis
la simple inclusions #include <adviOGL.h> suffira pour que le linking e fasse
correctement.

*/

#ifndef _ADVIOGL_
#  define _ADVIOGL_


#ifdef _MSC_VER   //Sur VC++
#  define USING_VCPP
#  ifndef ADVIOGL_COMPIL    //C'est une constante dfinit lors de la compilation de la lib elle mme.
#    pragma comment(lib,"adviOGL")
#    pragma comment(lib,"OpenGL32")
#    pragma comment(lib,"GlU32")
#  endif
#else
#  define USING_DEVCPP
#endif


#include <windows.h>
#include <GL/gl.h> 
#include <GL/Glu.h>

//La bibliothque advio2 fournit le support pour manipuler la fentre principale et les entres/sorties.
#include <advio2.h>

using namespace advio2;

/*
  La manipulation de la classe n'est pas gniale : car pour ne pas sacrifier la conception de
  mes programmes, le thread principale ne devient pas forcment (et en fait, ne devient jamais)
  le thread graphique (contrairement  glut au travers de glutMainLoop() par exemple). Ce qui
  fait que l'on ne peut manipuler et utiliser les fonctions OpenGL qu' l'intrieur des fonctions
  de rappel que vous dfinissez pour l'objets dont vous vous servez.

  Pour initialisez la bibliothque vous devez appeler advInit() puis vous obtener l'instance
  de la classe graphics  utiliser au travers de advGetOGL().
*/

//Cre une fentre OpenGL et initialise OpenGL pour que vous puissiez utiliser les fonctionnalit que fournit cette bibliothque. Le paramtre est une fonction de rappel dans laquel vous devez faire les initialisation que vous voulez.
void advInit(int x=400,int y=400,void(*InitFunc)(void)=NULL);

//Dtruit la fentre OpenGL et dsinitialise la bibliothque. Vous n'tes pas oblig d'appelez cette fonction  la fin de votre programme.
void advUnInit();

//Renvoie une rfrence vers un objets de type "graphics" que vous pouvez utilisez pour manipuler la fentre OpenGL (clavier, souris, etc.). Mais je vous conseilel fortement de ne pas dessiner sur cet objet.
graphics& advGetOGL();

//La fonction se mets en pause jusqu' ce que la fentre OpenGL soit ferm (vous avez appel advUnInit() dans votre programme).
void advWaitEnd();

//Echange les buffers d'affichage. Pour l'instant, vous ne pouvez pas faire de simple buffering.
void advSwapBuffers();

//Dfinie la fonction de rappel qui est appel pour grer l'affichage d'une nouvelle image.
void advSetDrawCallBack(void(*CallBackFunction)()=NULL);

//Dfinie la fonction de rappel qui est appel pour grer le raffichage aprs que la fentre ait t masqu. Ce callback est inutile si vous utilisez dj celui de l'vnement Draw.
void advSetPaintCallBack(void(*CallBackFunction)()=NULL);

//Fait appeler la fonction function par le fentre OpenGL.
void advCall(void (function)(void));



#endif


